<?php
if (!defined('ABSPATH')) {
    exit;
}

$get_md_woocommerce_shipping_method_format = get_option('md_woocommerce_shipping_method_format', true);
if (isset($get_md_woocommerce_shipping_method_format) && !empty($get_md_woocommerce_shipping_method_format)) {
    $chk = $get_md_woocommerce_shipping_method_format;
}
?>

<tr class="shipping">
    <th>Shipping</th>
    <td>
        <?php
        if (!empty($available_methods)) {
            $get_what_to_do_method = get_option('what_to_do_method');
            if (!empty($get_what_to_do_method)) {
                if ($get_what_to_do_method == 'allow_customer') {
                    $available_methods = $available_methods;
                } elseif ($get_what_to_do_method == 'apply_highest') {
                    $max = -9999999;
                    $apply_highest = array();
                    $key = '';
                    foreach ($available_methods as $k => $v) {
                        if ($v->cost > $max) {
                            $max = $v->cost;
                            $key = $k;
                            $apply_highest = $v;
                        }
                    }
                    $apply_highest_method[$key] = $apply_highest;
                    $available_methods = $apply_highest_method;
                } elseif ($get_what_to_do_method == 'apply_smallest') {
                    $min = 9999999;
                    $apply_smallest = array();
                    $key = '';
                    foreach ($available_methods as $k => $v) {
                        if ($v->cost < $min) {
                            $min = $v->cost;
                            $key = $k;
                            $apply_smallest = $v;
                        }
                    }
                    $apply_smallest_method[$key] = $apply_smallest;
                    $available_methods = $apply_smallest_method;
                }
            }
        }
        if (1 < count($available_methods)) :
            $sort_order = array();
            $getSortOrder = get_option('wc_sortable_order');
            if (isset($getSortOrder) && !empty($getSortOrder)) {
                foreach ($getSortOrder as $sort) {
                    $sort_order[$sort] = array();
                }
            }
            foreach ($available_methods as $carrier_id => $carrier) {
                $carrier_name = $carrier->id;

                if (array_key_exists($carrier_name, $sort_order)) {
                    $sort_order[$carrier_name][$carrier_id] = $available_methods[$carrier_id];
                    unset($available_methods[$carrier_id]);
                }
            }
            foreach ($sort_order as $carriers) {
                $available_methods = array_merge($available_methods, $carriers);
            }


            if (get_option('md_woocommerce_shipping_method_format') === 'select') :
                ?>

                <select name="shipping_method[<?php echo $index; ?>]" data-index="<?php echo $index; ?>" id="shipping_method_<?php echo $index; ?>" class="shipping_method">
                    <?php foreach ($available_methods as $method) : ?>
                        <option value="<?php echo esc_attr($method->id); ?>" <?php selected($method->id, $chosen_method); ?>><?php echo wp_kses_post(wc_cart_totals_shipping_method_label($method)); ?></option>
                    <?php endforeach; ?>
                </select>

            <?php else : ?>		



                <ul id="shipping_method">
                    <?php
                    foreach ($available_methods as $method) :
                        $get_extra_shipping_method_array = get_option('extra_' . $method->id . '_settings');
//                        if (!empty($get_extra_shipping_method_array)) {
                            ?>
                            <li>
                                <?php
                                $tool_tip_html = '';
                                $estimated_delivery = isset($get_extra_shipping_method_array['estimation_delivery']) ? $get_extra_shipping_method_array['estimation_delivery'] : '';

                                if ($get_extra_shipping_method_array['shipping_description'] != '') {
                                    $tool_tip_html .='<div class="extra-flate-tool-tip"><a href="#" data-tooltip="' . $get_extra_shipping_method_array['shipping_description'] . '"><i class="fa fa-question-circle fa-lg"></i></a></div>';
                                }
                                printf($tool_tip_html . '<label class="shipping_method_tooltip" id="hover-tips" for="shipping_method_%1$d_%2$s"><input type="radio" name="shipping_method_[%1$d]" data-index="%1$d" id="shipping_method_%1$d_%2$s" value="%3$s" class="shipping_method" %4$s />
									%5$s <br/><span>%6$s</span></label>', $index, sanitize_title($method->id), esc_attr($method->id), checked($method->id, $chosen_method, false), wc_cart_totals_shipping_method_label($method), $estimated_delivery);
                                do_action('woocommerce_after_shipping_rate', $method, $index);
                                ?>                
                            </li>
                        <?php //}
                    endforeach;
                    ?>
                </ul>
            <?php endif; ?>
        <?php elseif (1 === count($available_methods)) : ?>
            <?php
            $method = current($available_methods);
            $get_extra_shipping_method_array = get_option('extra_' . $method->id . '_settings');
            $estimated_delivery = isset($get_extra_shipping_method_array['estimation_delivery']) ? $get_extra_shipping_method_array['estimation_delivery'] : '';
            $tool_tip_html = '';
            if ($get_extra_shipping_method_array['shipping_description'] != '') {
                $tool_tip_html .='<div class="extra-flate-tool-tip"><a href="#" data-tooltip="' . $get_extra_shipping_method_array['shipping_description'] . '"><i class="fa fa-question-circle fa-lg"></i></a></div>';
            }
            printf($tool_tip_html . ' %3$s <br/> <span>%4$s</span><input type="hidden" name="shipping_method[%1$d]" data-index="%1$d" id="shipping_method_%1$d" value="%2$s" class="shipping_method" />', $index, esc_attr($method->id), wc_cart_totals_shipping_method_label($method), $estimated_delivery);
            do_action('woocommerce_after_shipping_rate', $method, $index);
            ?>
        <?php elseif (!WC()->customer->has_calculated_shipping()) : ?>
            <?php echo wpautop(__('Shipping costs will be calculated once you have provided your address.', 'woocommerce')); ?>
        <?php else : ?>
            <?php echo apply_filters(is_cart() ? 'woocommerce_cart_no_shipping_available_html' : 'woocommerce_no_shipping_available_html', wpautop(__('There are no shipping methods available. Please double check your address, or contact us if you need any help.', 'woocommerce'))); ?>
        <?php endif; ?>

        <?php if ($show_package_details) : ?>
            <?php echo '<p class="woocommerce-shipping-contents"><small>' . esc_html($package_details) . '</small></p>'; ?>
        <?php endif; ?>
        <?php if (is_cart() && !$index) : ?>
            <?php woocommerce_shipping_calculator(); ?>
<?php endif; ?>
    </td>
</tr>
<script>
    jQuery(document).ready(function() {
        jQuery(".extra-flate-tool-tip").parent().css("position", "relative");
    });
</script>